<template>
  <Layout :show-logo="false">
    <!-- Author intro -->
    <Author :show-title="true" />

    <div id="nav">
    <span class="item" v-for="courses, week in byWeek">
    <!--g-link :to="courses[0].week.path">{{week}}</g-link-->
    <a :href="['#', week.split(' ').join('-') ].join('')">{{week}}</a>
    <!--g-link :to="['#', week.split(' ').join('-') ].join('')" absolute="false">{{week}}</g-link-->
    </span>
    <ToggleTheme />
    </div>
    <!-- List posts -->
    <div class="posts">
      <!--PostCard v-for="edge in $page.posts.edges" :key="edge.node.id" :post="edge.node" /-->
      <div class="weekview" v-for="courses, week in byWeek">
      <section :id="week | slugable">
          <h3 >{{week}}</h3>
            <div class="weekgrid">
              <div class="weeksection" :class="{ 'hint' : course.hint == 'yes'}" v-for="course in courses">
                <PostCard :key="course.id" :post="course" />
              </div>
            </div>
        </section>
    </div>
    </div>

  </Layout>
</template>

<page-query>
query {
  posts: allPost(sortBy: "number", order: ASC) {
    edges {
      node {
        id
        title
        week {
          title
          path
        }
        hint
        number
        description
        path
        ...on Post {
        id
        title
        week {
          title
          path
        }
        number
        path
        }

      }
    }
  }
}
</page-query>



<script>
import Author from '~/components/Author.vue'
import PostCard from '~/components/PostCard.vue'
import ToggleTheme from '~/components/ToggleTheme.vue'
import $ from 'jquery'

export default {
  components: {
    Author,
    PostCard,
    ToggleTheme
  },
  metaInfo: {
    title: 'Home'
  },
  computed:{
   byWeek(){
     return this.$page.posts.edges.reduce((acc, user) => {
       (acc[user.node.week.title] = acc[user.node.week.title] || []).push(user.node)
       return acc
     }, {})
   }

   },
   mounted(){
     var sections = $('section')
  , nav = $('#nav')
  , nav_height = nav.outerHeight()
  , nav_top = nav.offset().top;

$(window).ready(function(){
  nav.find('a').removeClass('active');
  sections.removeClass('active');

  var elem = $('#' + window.location.hash.replace('#', ''));
  console.log(elem)
  if(elem) {
    $('html, body').stop().animate({
      scrollTop: elem.offset().top - nav_height + 1
    }, 1000);
  }

})


$(window).on('scroll', function () {
  var cur_pos = $(this).scrollTop();

if(cur_pos>nav_top){nav.addClass( "sticky" )}
else{nav.removeClass( "sticky" )}
  
  var is_on_section = false;
  sections.each(function() {
    var top = $(this).offset().top - nav_height,
        bottom = top + $(this).outerHeight();

    if (cur_pos+40 >= top && cur_pos <= bottom) {
      nav.find('a').removeClass('active');
      sections.removeClass('active');
      is_on_section = true;
      $(this).addClass('active');
      nav.find('a[href="#'+$(this).attr('id')+'"]').addClass('active');
    }
  });
  if(is_on_section == false){
    nav.find('a').removeClass('active');
      sections.removeClass('active');
  }

});

nav.find('a').click( function (event) {
event.preventDefault();

  var $el = $(this)
    , id = $el.attr('href');
  $('html, body').stop().animate({
    scrollTop: $(id).offset().top - nav_height + 2
  }, 800);

  return false;
});
   }
}
</script>
